<?php

// ViaThinkSoft Flash Version Library
// Licensed under GPLv3

# error_reporting(E_ALL | E_NOTICE | E_STRICT | E_DEPRECATED);

require_once __DIR__ . '/../downloading/downloading.inc.php';

define('DEFAULT_FLASH_VERSION_CACHE_TIME', 30 * 24 * 60 * 60); // 30 days

# echo cachedFlashVersion(DEFAULT_FLASH_VERSION_CACHE_TIME);

function cachedFlashVersion($max_cache_age) {
	$cache_file = __DIR__ . '/flash_version.cache';
	$cache_exists = file_exists($cache_file);

	if ($cache_exists) {
		$fileage = time()-filemtime($cache_file);
		$cache_contents = file_get_contents($cache_file);
	}

	if (($cache_exists) && ($fileage <= $max_cache_age)) {
		return $cache_contents;
	} else {
		$version = getLatestFlashVersion();

		if (!$version) {
			// Use the cache another time
			if ($cache_exists) {
				return $cache_contents; // even if it is older than $max_cache_age
			} else {
				return false;
			}
		}

		$h = fopen($cache_file, 'w');
		if (!$h) return $version;
		if (!fwrite($h, $version)) return $version;
		fclose($h);

		return $version;
	}
}

function getLatestFlashVersion() {
	$url = 'http://www.adobe.com/software/flash/about/';

	// this is not working inside a tor wrapper
	// $cont = file_get_contents($url);

	$cont = curl_simpe_get($url);

	if (!$cont) return false;

	$regex = '@<td>(\\d+)\\.(\\d+)\\.(\\d+)\\.(\\d+)</td>@';

	$version = '';

	preg_match_all($regex, $cont, $m, PREG_SET_ORDER);

	$out = array();
	foreach ($m as &$x) {
		$out[$x[1]][$x[2]][$x[3]][$x[4]] = true;
	}

	# Now find the largest version

	# Segment 1
	$max = -1;
	foreach ($out as $n => &$u) {
		if ($n > $max) $max = $n;
	}
	if ($max == -1) return false;
	$out = $out[$max];
	$version .= "$max,";

	# Segment 2
	$max = -1;
	foreach ($out as $n => &$u) {
		if ($n > $max) $max = $n;
	}
	if ($max == -1) return false;
	$out = $out[$max];
	$version .= "$max,";

	# Segment 3
	$max = -1;
	foreach ($out as $n => &$u) {
		if ($n > $max) $max = $n;
	}
	if ($max == -1) return false;
	$out = $out[$max];
	$version .= "$max,";

	# Segment 4
	$max = -1;
	foreach ($out as $n => &$u) {
		if ($n > $max) $max = $n;
	}
	if ($max == -1) return false;
	$out = $out[$max];
	$version .= $max;

	return $version;
}

?>
