<?php

// ViaThinkSoft YouTube Downloading Functions
// Licensed under GPLv3
// Revision: 2016-12-07 00:00
// Functionality last verified: 2015-12-04 00:00

include_once __DIR__ . '/../flash_version/flash_version.inc.php';
include_once __DIR__ . '/../misc/string_functions.inc.php';
include_once __DIR__ . '/../misc/windows.inc.php';

# !!!!!!!!!!!!!!!!!!!!!! TEST !!!!!!!!!!!!!!!!!!!!!!!
/*
#$y = new YouTubeDownloader('https://www.youtube.com/watch?v=u9o3PRFf2c4');
#$y = new YouTubeDownloader('https://www.youtube.com/watch?v=iRYvuS9OxdA');
$y = new YouTubeDownloader('https://www.youtube.com/watch?v=ux9NNwEfW2M');
#$y = new YouTubeDownloader('https://www.youtube.com/watch?v=JsQN3yZjRCI');
echo "---- VI 3 ----\n";
print_r($y->getVideoInfo3());
#echo "---- VI 2 ----\n";
#print_r($y->getVideoInfo2());
echo "---- VI 1 ----\n";
print_r($y->getVideoInfo1());
die();
*/

# ----------------------------------------------------------------

// QUE: utf8 in vi1 und vi2 decoden?
// FUT: VI2: [storyboard_spec] aufschlsselung "#" vs "|" verbessern / herausfinden?
// FUT: iwa einsetzen? tor geht nicht!
// FUT: das format/itag zeigen, das standardgem geladen wird (flv), siehe yt downloader 1.0
// FUT: highest quality for mime format X
// QUE: wie lange geht das gut? wie realittsgetreu ist die abfrage? regelmig alles checken. testcases.
// TDA: publication
// anhand von glob("* (YT $vid)" erkennen ob bereits heruntergeladen ? -> kein traffic notwendig dann und title kann gendert werden
// shutdown function: delete temp files?
// TODO: funktioniert alles auch wenn zielname in directory ist? (file_exists == false!)
// TODO: in html sind weitere infos ("VI3"): regions allowed, is family friendly
// TODO: videoduplikate anhand video-id+itag im dateinamen erkennen, nicht an komplett bereinstimmenden videotitel
// TODO: anstelle von dem watch-7 container knnte man VI2 alternativ aus der "args" json struktur auslesen.
// TODO: -H "Origin: http://www.youtube.com"  und weitere Dinge machen, um YouTube noch staerker zu imminieren
// TODO: is VI2 completely removed?
// TODO: age restricted videos download?

# ----------------------------------------------------------------

/*

// == The difference between VI1, VI2 and VI3 (video info) ==
// VI1 is taken from https://www.youtube.com/get_video_info?video_id= while VI2 is taken from "flashvars" in the HTML page.
// VI1 works even if the video is age-restricted.
// VI1, VI2 and VI3 have different contents, but the main things like are the same.
// VI3 is extracted from the JSON data in the HTML page. VI3 is also fully present if an video is restricted because of music content.

*/

# ----------------------------------------------------------------

require_once __DIR__ . '/../misc/windows.inc.php';

require_once __DIR__ . '/../misc/string_functions.inc.php';

require_once __DIR__ . '/../downloading/downloading.inc.php';

require_once __DIR__ . '/../flash_version/flash_version.inc.php';

# ----------------------------------------------------------------

class YouTubeException extends Exception {

}

# ----------------------------------------------------------------

/* EXAMPLE */

/*
$ytd = new YouTubeDownloader('http://www.youtube.com/watch?v=...');
# $ytd->setPreferHTTPS(true);
# $ytd->getDownloader()->setForceTor(false);
# $ytd->setUseUTF8Filenames(false);
# $ytd->setUseWindowsFilenames(true);
# $ytd->setUseFallbackHost(true);
# $ytd->setFormatIndex(0); // 0 = highest quality
$filename = $ytd->downloadToDir(__DIR__ . '/downloaded/');
*/

class YouTubeDownloader {
	# --- Constant: version

	public function getVersion() {
		return '2016-12-07 00:00';
	}

	# --- Configuration: prefer_https

	private $cfg_prefer_https = true;

	public function getPreferHTTPS() {
		return $this->cfg_prefer_https;
	}

	public function setPreferHTTPS($val) {
		$this->cfg_prefer_https = $val;
	}

	# --- Configuration: fileNameTemplate
	#     Valid tokens in $cfg_fileNameTemplate:
	#     {FILENAME}
	#     {VID}
	#     {FMT_IDX}
	#     {ITAG}
	#     {EXTENSION}

	private $cfg_fileNameTemplate = '{FILENAME} (YT {VID}, FMT #{FMT_IDX}-{ITAG}){EXTENSION}';

	public function getFileNameTemplate() {
		return $this->cfg_fileNameTemplate;
	}

	public function setFileNameTemplate($val) {
		$this->cfg_fileNameTemplate = $val;
	}

	# --- Configuration: useFallbackHost

	private $cfg_use_fallback_host = true;

	public function getUseFallbackHost() {
		return $this->cfg_use_fallback_host;
	}

	public function setUseFallbackHost($val) {
		$this->cfg_use_fallback_host = $val;
	}

	# --- Configuration: useUTF8Filenames

	private $cfg_use_utf8_filenames = false;

	public function getUseUTF8Filenames() {
		return $this->cfg_use_utf8_filenames;
	}

	public function setUseUTF8Filenames($val) {
		$this->cfg_use_utf8_filenames = $val;
	}

	# --- Configuration: useWindowsFilenames

	private $cfg_windows_filenames = true;

	public function getUseWindowsFilenames() {
		return $this->cfg_windows_filenames;
	}

	public function setUseWindowsFilenames($val) {
		$this->cfg_windows_filenames = $val;
	}

	# --- Configuration: tempDir

	private $cfg_temp_dir = '/tmp';

	public function getTempDir() {
		return $this->cfg_temp_dir;
	}

	protected function moveTmpFileIfPossible($file, $newdir) {
		if (is_null($file)) return null;
		$newname = $newdir.'/'.basename($file);
		if (file_exists($file)) rename($file, $newname);
		return $newname;
	}

	public function setTempDir($val) {
		if (substr($val, -1) == '/') $val = substr($val, 0, strlen($val)-1);
		$this->tmp_targetfile = $this->moveTmpFileIfPossible($this->tmp_targetfile, $val);
		$this->tmp_cookiejar  = $this->moveTmpFileIfPossible($this->tmp_cookiejar,  $val);
		$this->cfg_temp_dir = $val;
		$this->generateTempFileNames();
	}

	# --- Attribute: formatIndex

	private $format_idx = 0; /* highest quality. the higher, the less the quality. */

	public function getFormatIndex() {
		return $this->format_idx;
	}

	public function setFormatIndex($val) {
		$formats = $this->getFormats();
		if (!isset($formats[$val])) {
			$this->delTempFiles();
			throw new YouTubeException('A format with index '.$val.' does not exist for this video. Max is: '.(count($formats)-1).'!');
		}
		$this->format_idx = $val;
	}

	# --- Attribute: downloader

	private $downloader = null;

	public function getDownloader() {
		return $this->downloader;
	}

	protected function setDownloader($val) {
		$this->downloader = $val;
	}

	protected function newDownloader() {
		$this->downloader = new VTSDownloader();
	}

	# --- Attribute: videoID

	private $video_id = null;

	public function getVideoID() {
		return $this->video_id;
	}

	protected function setVideoID($val) {
		$this->video_id = $val;
	}

	protected function retrieveVideoID($url) {
		$vid = YouTubeUtils::getVideoIDFromURL($url);

		if ($vid === false) {
			$this->delTempFiles();
			throw new YouTubeException('Cannot extract video ID from URL "'.$url.'". Is this a YouTube URL?');
		}

		$this->setVideoID($vid);
	}

	# --- Virtual Attribute: canonicalURL

	public function canonicalURL($https = false, $short = false) {
		return YouTubeUtils::createURL($this->getVideoID(), $https, $short);
	}

	# --- Virtual Attribute: fileExtension

	public function getFileExtension() {
		$format = $this->getFormatInfo();
		assert(isset($format['extension'])); // set in getFormats()
		return $format['extension'];
	}

	# --- Virtual Attribute: formatInfo

	public function getFormatInfo() {
		$formats = $this->getFormats();
		return $formats[$this->getFormatIndex()];
	}

	# --- Virtual Attribute: iTag

	public function getITag() {
		$format = $this->getFormatInfo();

		if (!isset($format['itag'])) {
			$this->delTempFiles();
			throw new YouTubeException('Could not parse iTag from VI!');
		}

		return $format['itag'];
	}

	public function setITag($itag) {
		$formats = $this->getFormats();

		foreach ($formats as $format_idx => &$format) {
			if (!isset($format['itag'])) {
				$this->delTempFiles();
				throw new YouTubeException('Could not parse iTag from VI!');
			}

			if ($format['itag'] == $itag) {
				$this->setFormatIndex($format_idx);
				return;
			}
		}

		$this->delTempFiles();
		throw new YouTubeException("ITag $itag does not exist for this video.");
	}

	# --- Virtual Attribute: defaultFileName

	public function getDefaultFileName() {
		$title = $this->getTitle();
		if (!$title) {
			$this->delTempFiles();
			throw new YouTubeException("Could not get the title.");
		}

		$filename = $title;

		if (!$this->getUseUTF8Filenames()) {
			$filename = utf8_decode($filename);
		}

		if ($this->getUseWindowsFilenames()) {
			$filename = sanitize_filename_windows($filename);
			if (!$filename) {
				$this->delTempFiles();
				throw new YouTubeException("Could not sanitize filename for Windows.");
			}
		}

		$fn = $this->getFileNameTemplate();
		$fn = str_replace('{FILENAME}',  $filename,                 $fn);
		$fn = str_replace('{VID}',       $this->getVideoID(),       $fn);
		$fn = str_replace('{FMT_IDX}',   $this->getFormatIndex(),   $fn);
		$fn = str_replace('{ITAG}',      $this->getITag(),          $fn);
		$fn = str_replace('{EXTENSION}', $this->getFileExtension(), $fn);

		return $fn;
	}

	# ----------------------------------------------------------------

	// which version info should be preferred to be downloaded first?
	// will be downloaded if none is yet in cache
	// - true is better since VI1 it is also available on mature rated videos. getTitle() or download will then not fail.
	// - true is also better, because VI1 is not available for videos which are non-available because of music copyright;
	//   VI3 would be still be available, so that the YT downloader will try to download the playback urls.
	//   But the main server provides 403 Forbidden, and the fallback server provides 404 Not Found.
	protected $pref_video_info1 = true;

	protected function getPrefVideoInfo() {
		$vi = 0;
		if ($this->pref_video_info1) {
			if (!$this->isVideoInfo1Cached() && $this->isVideoInfo3Cached()) {
				$vi = 3;
			} else {
				$vi = 1;
			}
		} else {
			if (!$this->isVideoInfo3Cached() && $this->isVideoInfo1Cached()) {
				$vi = 1;
			} else {
				$vi = 3;
			}
		}

		if ($vi == 1) {
// There is a problem if we allow a fallback to VI3:
// VI3 also works for restricted videos, but the playback urls will still not work.
// Therefore, the user would get a 'cURL error 22' (HTTP 40x) instead of a easy-to-understand 'YouTube Error 150: Video not available due to ...' message
#			try {
				$videoinfo = $this->getVideoInfo1();
#			} catch (Exception $e) {
#				$videoinfo = $this->getVideoInfo3();
#			}
		} else if ($vi == 3) {
			try {
				$videoinfo = $this->getVideoInfo3();
			} catch (Exception $e) {
				$videoinfo = $this->getVideoInfo1();
			}
		}

		return $videoinfo;
	}

	# --- Virtual Attribute: title

	public function getTitle() {
		$videoinfo = $this->getPrefVideoInfo();

		if (!isset($videoinfo['title'])) {
			$this->delTempFiles();
			throw new YouTubeException('Could not get title from VI!');
		}

		return $videoinfo['title'];
	}

	# --- Virtual Attribute: videoInfo1

	private $cache_vi1 = null;

	public function __debugSetVI1($x) {
		$this->cache_vi1 = $x;
	}

	public function isVideoInfo1Cached() {
		return (!is_null($this->cache_vi1));
	}

	public function getVideoInfo1() {
echo "*** GET VI1\n";
		if ($this->isVideoInfo1Cached()) return $this->cache_vi1;

		// Get the video ID
		$vid = $this->getVideoID();

		// Get video informations
		$proto = $this->getPreferHTTPS() ? 'https' : 'http';
		$videoinfo = $this->getDownloader()->cURLGet("$proto://www.youtube.com/get_video_info?video_id=$vid");
		if (!$videoinfo) {
			$this->delTempFiles();
			throw new YouTubeException('Could not download video info 1. Details: ' . $this->getDownloader()->getLastError());
		}

		$videoinfo = str_replace('&', "\n", $videoinfo); // in VI2 this is \u0026, the "root '&' separator"
		$out = array();
		$this->_rec_video_info($videoinfo, 1, '\u0026', $out, 0, array());

		// Check for errors
		if (!isset($out['status'])) {
			$this->delTempFiles();
			throw new YouTubeException('Could not parse status from VI1!');
		}
		if ($out['status'] == 'fail') {
			// YouTube Error
			$this->delTempFiles();
			throw new YouTubeException('YouTube Error '.$out['errorcode'].': '.$out['reason']);
		} else if ($out['status'] != 'ok') {
			// Unknown states
			$this->delTempFiles();
			throw new YouTubeException('Status "'.$out['status'].'" not recognized by downloader application. Please report this issue as bug.');
		}

		$this->cache_vi1 = $out;
		return $out;
	}

	# --- Virtual Attribute: combinedVideoInfo

	public function getCombinedVideoInfo() {
		$vi1 = $this->getVideoInfo1();
		# $vi2 = $this->getVideoInfo2();
		$vi3 = $this->getVideoInfo3();

		if ($this->pref_video_info1) {
			$cvi = array_merge($vi3, $vi1); // VI1 overrides VI3
		} else {
			$cvi = array_merge($vi1, $vi3); // VI3 overrides VI1
		}

		return $cvi;
	}

	# --- Virtual Attribute: videoInfo2

	private $cache_vi2 = null;

	public function isVideoInfo2Cached() {
		return (!is_null($this->cache_vi2));
	}

	# These video infos found in "flashvars" are more extended. However the other video infos do contain elements which are not in these parameters.
	public function getVideoInfo2() {
		if ($this->isVideoInfo2Cached()) return $this->cache_vi2;

		$html = $this->getHTML();

		# Beispiel: http://www.youtube.com/watch?v=4jTPbcnqPxQ (7,11,12)
		preg_match_all('@flashvars=\\\\"(.*)\\\\"@ismU', $html, $m);

		if (!isset($m[1][0])) {
			# Aus irgendeinem Grund gibt es Videos mit flashvars="..." und manche mit <param name="flashvars" value="..."> !!!
			# Beispiel: http://www.youtube.com/watch?v=ZWHpcKXt-qQ (14,11,12)
			preg_match_all('@\\\\u003cparam name=\\\\"flashvars\\\\" value=\\\\"(.*)\\\\"\\\\u003e@ismU', $html, $m);

			if (!isset($m[1][0])) {
				$this->delTempFiles();
				throw new YouTubeException("flashvars not found (video info 2)");
			}
		}

		$cont1 = str_replace('\u0026amp;', "\n", $m[1][0]);

		$ary = array();
		$this->_rec_video_info($cont1, 1, '\u0026', $ary, 0, array());
		$this->cache_vi2 = $ary;
		return $ary;
	}

	# --- VI 3

	private $cache_vi3 = null;

	public function isVideoInfo3Cached() {
		return (!is_null($this->cache_vi3));
	}

	public function getVideoInfo3() {
echo "*** GET VI3\n";
		if ($this->isVideoInfo3Cached()) return $this->cache_vi3;

		$html = $this->getHTML();

		$pre  = 'var ytplayer = ytplayer || {};ytplayer.config = ';
		$post = ';ytplayer.load = function()';
		preg_match('@'.preg_quote($pre,'@').'(.+)'.preg_quote($post,'@').'@ismU', $html, $m);

		if (!isset($m[1])) {
			throw new YouTubeException('Cannot find VI3 in HTML!');
		}

		$r = json_decode($m[1], true);
		vi3_rec_decode($r);

		$ary = $r['args'];

		$this->cache_vi3 = $ary;
		return $ary;
	}

	private function _rec_video_info($a, $ebene, $last_separator, &$ary, $list_level, $tree) {
		// QUE: muss das so kompliziert sein? geht das nicht einfacherer / sauberer?
		$a = explode("\n", $a);
		foreach ($a as &$x) {
			if (($last_separator == '&') || ($last_separator == '\u0026')) {
				$b = explode('=', $x, 2);
				$name = $b[0];
				$val = isset($b[1]) ? $b[1] : null;
			} else {
				$name = null;
				$val = $x;
			}

			# Do not urldecode on listings (",") and splitting between host+parameters ("?")
			# QUE: ist das alles korrekt? wird urldecode() nicht zu oft und nicht zu wenig durchgefhrt?
			if (($last_separator != '?') && ($last_separator != ',')) {
				$v = urldecode($val);
			} else {
				$v = $val;
			}

			if ($name == 'ad_tag') {
				$ori_val = $v;
				if ($v[strlen($v)-1] == ';') $v = substr($v, 0, strlen($v)-1);
				$v = str_replace_once(';', '?', $v);
				$v = str_replace(';', '&', $v);
			} else if ($name == 'storyboard_spec') {
				$ori_val = $v;
				$v = str_replace_once('|', '?', $v);
				$v = str_replace('|', '&', $v);
			} else {
				$ori_val = null;
			}

			# todo: mehr?
			$always_use_list = false;
			if ($name == 'keywords')  $always_use_list = true;
			if ($name == 'fmt_list')  $always_use_list = true;
			if ($name == 'fexp')      $always_use_list = true; // fexp = experiments
			if ($name == 'sparams')   $always_use_list = true; // sparams = signed params
			if ($name == 'watermark') $always_use_list = true;

			# todo: mehr? keyword,title,author etc.
			# auf ein userfield wird kein url-schema angewandt.
			$user_field = false;
			if ($name == 'title')     $user_field = true;
			if ($name == 'reason')    $user_field = true; // ist zwar kein user-field aber in manchen sprachen wird bei dem GEMA-fehler (yt err #150) ein <a > eingefgt.

			$parent_1 = (count($tree) > 0) ? $tree[count($tree)-1] : null;
			$parent_2 = (count($tree) > 1) ? $tree[count($tree)-2] : null;
			// $parent_3 = (count($tree) > 2) ? $tree[count($tree)-3] : null;

			if ($parent_1 === 'fmt_list') {
				$v = str_replace('/', ',', $v);
			}

			if ($parent_2 == 'ad_tag') {
				if ($name == 'ytexp') {
					$v = str_replace('.', ',', $v);
				} else if ($name == 'k5') {
					$v = str_replace('_', ',', $v);
				} else if ($name == 'u') {
					$v = str_replace('|', ',', $v);
				}
			}

			if ($name == 'view_count') {
				$v = str_replace(',', '', $v);
				$v = str_replace('.', '', $v);
				$v = str_replace(' ', '', $v); # notwendig? ggf franzsisches format (1000-seperator).
			}

			if ((!$user_field) && (($always_use_list) || (preg_match(',(?! )', $v) && ($list_level < 1)))) { // if list_level >= 1: first "," (but not with following whitespace because of codec-listing) , then "&"
				$v = preg_replace(',(?! )', "\n", $v);

				$treex = $tree; $treex[] = $name ? $name : 0;
				if ($name) {
					$uri = explode("\n", $v);
					foreach ($uri as &$va) {
						$this->_rec_video_info($va, $ebene+1, ',', $ary[$name][], $list_level+1, $treex);
					}
				} else {
					$this->_rec_video_info($v, $ebene+1, ',', $ary, $list_level+1, $treex);
				}
			} else if ((!$user_field) && (/* (strpos($v, '?') !== false) && */ (preg_match('@^https{0,1}://@i', $v)))) {
				$m = explode('?', $v, 2);

				if ($name) {
					$ary[$name]['@url_complete'] = $ori_val ? $ori_val : $v;
					$ary[$name]['@url_base'] = $m[0];
					$treex = $tree; $treex[] = $name ? $name : 0;

					if (!isset($m[1])) {
						$ary[$name]['@url_params'] = array();
					} else {
						$this->_rec_video_info($m[1], $ebene+1, '?', $ary[$name]['@url_params'], $list_level, $treex);
					}
				} else {
					$ary['@url_complete'] = $ori_val ? $ori_val : $v;
					$ary['@url_base'] = $m[0];
					$treex = $tree; $treex[] = $name ? $name : 0;

					if (!isset($m[1])) {
						$ary['@url_params'] = array();
					} else {
						$this->_rec_video_info($m[1], $ebene+1, '?', $ary['@url_params'], $list_level, $treex);
					}
				}
			} else if ((!$user_field) && (strpos($v, '&') !== false)) {
				$v = str_replace('&', "\n", $v);

				$treex = $tree; $treex[] = $name ? $name : 0;
				$this->_rec_video_info($v, $ebene+1, '&', $ary, $list_level, $treex);

#				if ($name) {
#					$this->_rec_video_info($v, $ebene+1, '&', $ary[$name], $list_level, $treex);
#				} else {
#					$this->_rec_video_info($v, $ebene+1, '&', $ary[], $list_level, $treex);
#				}
			} else if ((!$user_field) && (($always_use_list) || (preg_match(',(?! )', $v) && ($list_level >= 1)))) { // if list_level >= 1: first "&" , then ","
				$v = preg_replace(',(?! )', "\n", $v);

				$treex = $tree; $treex[] = $name ? $name : 0;
				if ($name) {
					$uri = explode("\n", $v);
					foreach ($uri as &$va) {
						$this->_rec_video_info($va, $ebene+1, ',', $ary[$name][], $list_level+1, $treex);
					}
				} else {
					$this->_rec_video_info($v, $ebene+1, ',', $ary, $list_level+1, $treex);
				}
			} else {
				if (is_null($v)) continue;
				if ($name) {
					# todo: achtung: hier knnten werte berschrieben werden... (?era=x&era=y == ?era=y)
					$ary[$name] = $v;
				} else {
					if (count($a) == 1) {
						$ary = $v;
					} else {
						$ary[] = $v;
					}
				}
			}
		}
	}

	# --- Virtual Attribute: latestFlashVersion

	protected function getLatestFlashVersion() {
		return cachedFlashVersion(DEFAULT_FLASH_VERSION_CACHE_TIME);
	}

	# --- Virtual Attribute: formats

	public function getFormats() {
		# todo: less cryptic parameters ... but I need more informations

#xxx

		$vi = $this->getPrefVideoInfo();

		if (!isset($vi['url_encoded_fmt_stream_map'])) {
			$this->delTempFiles();
			throw new YouTubeException('VI Error: Could not find url_encoded_fmt_stream_map!');
		}
		$out = $vi['url_encoded_fmt_stream_map'];
		if (count($out) == 0) {
			$this->delTempFiles();
			throw new YouTubeException('VI Error: url_encoded_fmt_stream_map is empty!');
		}

		if (!isset($vi['fmt_list'])) {
			$this->delTempFiles();
			throw new YouTubeException('VI Error: Could not find fmt_list!');
		}
		$fmt_list = $vi['fmt_list'];
		if (count($fmt_list) == 0) {
			$this->delTempFiles();
			throw new YouTubeException('VI Error: fmt_list is empty!');
		}

		if (!isset($vi['adaptive_fmts'])) {
			$this->delTempFiles();
			throw new YouTubeException('VI Error: Could not find adaptive_fmts!');
		}
		$adaptive_fmts = $vi['adaptive_fmts'];
		if (count($fmt_list) == 0) {
			$this->delTempFiles();
			throw new YouTubeException('VI Error: adaptive_fmts is empty!');
		}


		/*
		foreach ($fmt_list as $n => &$y) {
			// Add additional informations from fmt_list to our preferred VI
			$out[$n]['list_params'] = $y;

			// Add file-extension calculated from the mime-type and append it to the output
			if (!isset($out[$n]['type'])) {
				$this->delTempFiles();
				throw new YouTubeException('Could not parse type of fmt_info from VI!');
			}
			$out[$n]['extension'] = $this->mimeToExt($out[$n]['type']);
		}
		*/
		foreach ($out as $n => $y) {
			if (isset($fmt_list[$n])) {
				// [1 Dec 2015] For some reason some videos have fmt_list 5 items and url_encoded_fmt_stream_map 6 items! But only VI1, not VI3
				$out[$n]['list_params'] = $fmt_list[$n];
			}
			$out[$n]['extension'] = $this->mimeToExt($out[$n]['type']);
		}

		foreach ($adaptive_fmts as $f) {
			$out[] = $f;
		}

		return $out;
	}

	# --- Virtual Attribute: html

	private $cache_html = null;

	protected function isHTMLCached() {
		return (!is_null($this->cache_html));
	}

	public function __debugSetHTMLcache($x) {
		$this->cache_html = $x;
	}

	protected function getHTML() {
		if ($this->isHTMLCached()) return $this->cache_html;

		// Build canonical watch url.
		$url = $this->canonicalURL($this->getPreferHTTPS());

		// Get page contents
		$cont = $this->getDownloader()->cURLGet($url, $this->curl_params);
		if (!$cont) {
			$this->delTempFiles();
			throw new YouTubeException('Could not request page '.$url.' . Details: ' . $this->getDownloader()->getLastError());
		}

		$this->cache_html = $cont;

		return $cont;
	}

	# --- Helper Functions

	protected /* static */ function mimeToExt($mime) {
		// remove codecs info
		$x = explode(';', $mime, 2);
		$mime = $x[0];

		if ($mime == 'video/webm')  return '.webm';
		if ($mime == 'video/3gpp')  return '.3gp';
		if ($mime == 'video/3gpp2') return '.3g2'; // currently not used (Nov 2012)
		if ($mime == 'video/mp4')   return '.mp4';
		if ($mime == 'video/x-flv') return '.flv'; // Alternativ: '.f4v';

		// return '';
		$this->delTempFiles();
		throw new YouTubeException('Unknown MIME type "'.$mime.'"! Please report this issue as bug.');
	}

	# --- Initialization functions

	private   $curl_params    = '';
	protected $tmp_cookiejar  = null;
	protected $tmp_targetfile = null;
	protected $player_js_cache_dir = null;

	protected function generateTempFileNames() {
		// Generate temporary file names
		$uniq = uniqid('', true);
		if (!file_exists($this->tmp_targetfile)) $this->tmp_targetfile = $this->getTempDir() . '/tmp.'.$uniq.'.yt_downloader_downloaded';
		if (!file_exists($this->tmp_cookiejar)) {
			$this->tmp_cookiejar  = $this->getTempDir() . '/tmp.'.$uniq.'.yt_downloader_cookiejar';
			$this->initCurlParams();
		}
	}

	protected function initCurlParams() {
		$this->curl_params = '';
		// Try to emulate a real request as good as possible
		$flash_version = $this->getLatestFlashVersion(); // is cached
		if ($flash_version) $this->curl_params .= ' -H "x-flash-version: '.$flash_version.'"';
		$this->curl_params .= ' -b '.escapeshellarg($this->tmp_cookiejar);
		$this->curl_params .= ' -c '.escapeshellarg($this->tmp_cookiejar);
	}

	public function __construct($url) {
		$this->retrieveVideoID($url);
		$this->generateTempFileNames();
		$this->initCurlParams();
		$this->newDownloader();
	}

	# --- Destruction functions

	protected function delTempFiles() {
		if (file_exists($this->tmp_targetfile)) unlink($this->tmp_targetfile); # we just do it, even if just the renaming failed... (TODO?)
		if (file_exists($this->tmp_cookiejar))  unlink($this->tmp_cookiejar);
	}

	public function __destruct() {
		$this->delTempFiles();
	}

	# --- Downloader functions

	public function fixSig($sig) {
		$format = $this->getFormatInfo();

		$videoinfo = $this->getVideoInfo1();
		if ($videoinfo['use_cipher_signature'] != 'True') {
			return $sig;
		} else {
			$html = $this->getHTML();

			preg_match('|jsbin/([^/]+)/base.js|', $html, $m);
			$player_file_id = $m[1];
			$web_file = 'https://s.ytimg.com/yts/jsbin/'.$player_file_id.'/base.js';

			$dir = $this->player_js_cache_dir;
			if (!is_dir($dir)) {
				$is_temp = true;
				$dir = '/tmp';
			} else {
				$is_temp = false;
			}

			$localfile = $dir.'/'.$player_file_id.'.js';

			if (!file_exists($localfile)) {
				echo "Debug: $web_file --> $localfile\n";
				$this->getDownloader()->cURLDownload($web_file, $localfile, $this->curl_params);
			}

			$ret = YouTubeUtils::decipher_yt_signature($localfile, $sig);

			if ($is_temp) unlink($localfile);

			if ($ret === false) {
				$this->delTempFiles();
				throw new YouTubeException('Could not decrypt signature!');
			}

$ret = trim($ret);
#$ret = substr($ret, 0, 40).'.'.substr($ret, 40, strlen($ret)-40);
#echo "XX = $ret\n";

			return $ret;
		}
	}

	// Attention: This download URL expires and it is bound to the IP address which was used when requesting.
	// Also you need to send a referrer, see getDownloadReferer() .
	public function getDownloadURL($use_fallback_host = false) {
		$format = $this->getFormatInfo();

#test#print_r($format);

		if (!isset($format['url']['@url_complete'])) {
			$this->delTempFiles();
			throw new YouTubeException('Could not get url->@url_complete from current format!');
		}
		$download_url = $format['url']['@url_complete'];

		if ($use_fallback_host) {
			if (!isset($format['fallback_host'])) {
				$this->delTempFiles();
				throw new YouTubeException('Could not get fallback_host from current format!');
			}
			$fbhost = $format['fallback_host'];

			$download_url = preg_replace('@://(.*)/@U', '://'.$fbhost.'/', $download_url);
		}

		# Add signature
		// It seems that this is not available anymore. The signature is already added in $download_url
		// and $format does not contain 'sig' anymore. (May 3, 2014)
		if (isset($format['sig']) && (strpos($download_url, '&signature=') === false)) {
			$download_url .= '&signature=' . $this->fixSig($format['sig']);
		}
		// Added 06.12.2016
		// TODO: Currently, we don't support "use_cipher_signature=true" ...
		//       http://stackoverflow.com/questions/21510857/best-approach-to-decode-youtube-cipher-signature-using-php-or-js
		if (isset($format['s']) && (strpos($download_url, '&signature=') === false)) {
			$download_url .= '&signature=' . $this->fixSig($format['s']);
		}

		# Use HTTPS?
		# This does currently not work for the download url. (Last checked: 30,11,12)
		# Error: "Error 502 (Server Error)!!1"
		/*
		if ($this->getPreferHTTPS()) {
			$download_url = str_replace('http://', 'https://', $download_url);
		}
		*/

		return $download_url;
	}

	public function getDownloadReferer() {


#test#
			$url = $this->canonicalURL($this->getPreferHTTPS());
			return $url;



		$cont = $this->getHTML();

		// Find out the referer for the downloading
		preg_match_all('@(https{0,1}:\\\\/\\\\/s.ytimg.com\\\\/yt[^ "]*\\.swf)@sU', $cont, $m);
		if (!isset($m[1][0])) {
			// Without it videoplayback will give out 403, so it is a fatal error
			// $this->delTempFiles();
			// throw new YouTubeException('Could not find the swfbin referer');

			// At least try...
			$url = $this->canonicalURL($this->getPreferHTTPS());
			return $url;
		}

		$referer = $m[1][0];
		$referer = str_replace('\\/', '/', $referer);

		return $referer;
	}

	public function downloadToDir($dir, $allow_overwriting = false) {
		if (!is_dir($dir)) mkdir($dir, 0777, true); # force directories

		$fn = $dir . '/' . $this->getDefaultFileName();
		if (file_exists($fn) && (!$allow_overwriting)) {
			// it is already downloaded
			return $fn;
		}
		$this->downloadVideo($fn);
		return $fn;
	}

	public function downloadVideo($targetfile) {
		$download_url = $this->getDownloadURL(false);

		// Add the referer
		$add_params = '';
		$referer = $this->getDownloadReferer();
		if ($referer) $add_params .= ' --referer '.escapeshellarg($referer.';auto');

		// Download the file
		$add_params .= ' -k'; // Some cache servers use invalid certificates (CN=*.google.com, but server is googlevideo.com)
		$res = $this->getDownloader()->cURLDownload($download_url, $this->tmp_targetfile, $this->curl_params . $add_params);
		if ((!$res) && ($this->getUseFallbackHost())) {
			$download_url_fallback = $this->getDownloadURL(true);
			$res = $this->getDownloader()->cURLDownload($download_url_fallback, $this->tmp_targetfile, $this->curl_params . $add_params);
		}
		if (!$res) {
			$this->delTempFiles();
			throw new YouTubeException("Could not download the target file: $download_url (Referer: $referer) . Details: " . $this->getDownloader()->getLastError());
		}

		// Replace the target file
		$res = rename($this->tmp_targetfile, $targetfile);
		if (!$res) {
			$this->delTempFiles();
			throw new YouTubeException("Could not rename '".$this->tmp_targetfile."' to '$targetfile'. Deleted.");
		}
	}

}

# ----------------------------------------------------------------

class YouTubeUtils {
	# --- Attribute: downloader

	private $downloader = null;

	public function getDownloader() {
		return $this->downloader;
	}

	protected function setDownloader($val) {
		$this->downloader = $val;
	}

	protected function newDownloader() {
		$this->downloader = new VTSDownloader();
	}

	# --- Configuration: prefer_https

	private $cfg_prefer_https = true;

	public function getPreferHTTPS() {
		return $this->cfg_prefer_https;
	}

	public function setPreferHTTPS($val) {
		$this->cfg_prefer_https = $val;
	}

	# --- Construction

	public function __construct() {
		$this->newDownloader();
	}

	# --- Public functions

	# TD FUT: more utils like searching, uploading etc

	public function getPlayListVideoURLs($list_id, $https = false, $short = false) {
		$out = array();
		$vids = $this->getPlayListVideoIDs($list_id);
		foreach ($vids as &$vid) {
			$out[] = self::createURL($vid, $https, $short);
		}
		return $out;
	}

	public function performSearch($searchterm) {
		$proto = $this->getPreferHTTPS() ? 'https' : 'http';
		$out = array();

		$seite = 1;

		do {
			# TODO: urlencode OK?
			$url = $proto.'://www.youtube.com/results?search_query='.urlencode($searchterm).'&amp;page='.$seite;

			$cont  = $this->getDownloader()->cURLGet($url);
			if (!$cont) {
				if (isset($downloader)) $downloader->delTempFiles();
				throw new YouTubeException('GET error at '.$url);
			}

			# TODO: it is also possible that a search result has a list
			# <a href="/watch?v=PMd9eYXT0mM&amp;list=PLD476227DE0FD49FF"
			# TODO: better data-context-item-id="..." ?
			$out = array_merge($out, $this->grabVideosFromContent($cont));

			$seite++;
		} while (strpos($cont, '&amp;page='.$seite.'"') !== false);

		$out = array_values(array_unique($out));

		return $out;
	}

	protected function grabVideosFromContent($cont) {
		preg_match_all('@/watch\\?v=(.+)[&"\\\\]@U', $cont, $m);
		return $m[1];
	}

	public function getPlayListVideoIDs($list_id) {
		$proto = $this->getPreferHTTPS() ? 'https' : 'http';
		$url = $proto.'://www.youtube.com/playlist?list='.$list_id;
		return $this->grabVideosFromContinuationPage($url);
	}

	protected function grabVideosFromContinuationPage($url) {
		$out = array();

		$proto = $this->getPreferHTTPS() ? 'https' : 'http';

		$cont  = $this->getDownloader()->cURLGet($url);
		if (!$cont) {
			if (isset($downloader)) $downloader->delTempFiles();
			throw new YouTubeException('GET error at '.$url);
		}

		$out = $this->grabVideosFromContent($cont);

		$cont = html_entity_decode($cont);

		$regex = '@data-uix-load-more-href="(/browse_ajax\\?action_continuation=1&continuation=.+)"@U';

		while (preg_match($regex, $cont, $m)) {
			$url = $proto.'://www.youtube.com'.urldecode($m[1]);

			$cont  = $this->getDownloader()->cURLGet($url);
			if (!$cont) {
				if (isset($downloader)) $downloader->delTempFiles();
				throw new YouTubeException('GET error at '.$url);
			}
			$cont = str_replace('\u0026amp;', '&', $cont);

			$out = array_merge($out, $this->grabVideosFromContent($cont));

			$regex = '@(/browse_ajax\\?action_continuation=1&continuation=.+)\\\\@U';
		}

		$out = array_values(array_unique($out));

		return $out;
	}

	public function getChannelVideoIDs($channel) {
		$proto = $this->getPreferHTTPS() ? 'https' : 'http';
		$url   = $proto.'://www.youtube.com/user/'.$channel.'/videos';
		return $this->grabVideosFromContinuationPage($url);
	}

	# --- Public static functions

	public static function createURL($vid, $https = false, $short = false) {
		$protocol = $https ? 'https' : 'http';
		if ($short) {
			return $protocol . '://www.youtu.be/' . $vid;
		} else {
			return $protocol . '://www.youtube.com/watch?v=' . $vid;
		}
	}

	public static function getVideoIDFromURL($url) {
		// Extract video ID from the URL
		// TODO: are there more formats?

		$vid = false;

		# Usual format
		if (($vid === false) && (preg_match("@https{0,1}://(www\\.|)youtube\\.com/watch(.*)(&|\\?)v=(.+)&@ismU", $url.'&', $m))) {
			$vid = $m[4];
		}

		# Short format
		if (($vid === false) && (preg_match("@https{0,1}://(www\\.|)youtu\\.be/(.+)\$@ismU", $url, $m))) {
			$vid = $m[2];
		}

		return $vid;
	}

	# ---

	public static function decipher_yt_signature($baseJSfile, $signature) {
		$ary = file($baseJSfile);

		echo "SIG INP = $signature\n";

		// Cleanup signature (and avoid JavaScript injection)
		$signature = preg_replace('|[^A-F0-9\\.]+|sm', '', strtoupper($signature));

		echo "SIG CLN = $signature\n";

		// Remove all undeclared browser functions, so our console JavaScript interpreter can work
		array_unshift ($ary, 'var DUMMY = function() { return; }'."\n");
		foreach ($ary as &$x) {
			$x = preg_replace('|[\\$a-zA-Z\\._]*location[\\$a-zA-Z\\._]*|sm', '""', $x);
			$x = preg_replace('|[\\$a-zA-Z\\._]*navigator[\\$a-zA-Z\\._]*|sm', '""', $x);
			$x = preg_replace('|[\\$a-zA-Z\\._]*document\\.[\\$a-zA-Z\\._]*|sm', '""', $x);
			$x = str_replace('()""', '()', $x);
			while (strpos($x, '""""') !== false) $x = str_replace('""""', '""', $x);
			$x = str_replace('""(', 'DUMMY(', $x);
			$x = str_replace('window.console.log', 'DUMMY', $x);

			if ((strpos($x, '.split("")') !== false) && (strpos($x, '.join("")') !== false)) {
				$bry = explode('=function', $x, 2);
				$final_cmd = "console.log(".$bry[0].'("'.$signature.'")'.");";
			}

			if (isset($final_cmd)) {
				$x = str_replace(';})(_yt_player);', ';'.$final_cmd.'})(_yt_player);', $x);
			}
		}

		if (!isset($final_cmd)) return false;

		$tmpfile = tempnam('/tmp', 'YtSigDecipher');

		file_put_contents($tmpfile, implode("\n", $ary));

		# This requires executing "sudo aptitude install nodejs" once
		# The js command does not work in a TOR environment
		$out = array();
		$last_line = trim(exec('js '.$tmpfile, $out, $ec));

		echo "SIG OUT = $last_line\n";

		unlink($tmpfile);

		if ($ec != 0) return false;

		return $last_line;
	}
}

// TODO: oop
function vi3_rec_decode(&$r) {
	// TODO: this function acts unstable. minor changes change the result, e.g. "type" or [0] has wrong (too many) nested arrays

        foreach ($r as $key => &$value) {
                if (is_array($value)) {
                        vi3_rec_decode($value);
                } else {
			if ($key === '@url_complete') continue; // return;
			if ($key === '@url_base') continue; // return;
			$cc = count_chars($value, 0);

			$user_field = false;
			if ($key === 'title')     $user_field = true;
			if ($key === 'reason')    $user_field = true; // ist zwar kein user-field aber in manchen sprachen wird bei dem GEMA-fehler (yt err #150) ein <a > eingefgt.
			if ($key === 'vmap') $user_field = true;
			if ($key === 'gapi_hint_params') $user_field = true;
			if ($key === 'enabled_engage_types') $user_field = true;

			if ($key === 'type') $user_field = true;
			if ($key === 'mime') $user_field = true;

			if ($user_field) continue; // return;

			if (($key === 'excluded_ads') or ($key === 'data')) {
				// TODO: for some reasons, [0] entries are bugged if this code is active
				$aa = explode(';', $value);
				foreach ($aa as &$v) {
					$v = explode('=', $v);
					if ($key !== 'data') $v[1] = explode(',', $v[1]);
				}
				$value = $aa;

			} else if (($key !== 'type') && ($cc[ord('|')] >= 1)) {
				$value = explode('|', $value);
				vi3_rec_decode($value);
			} else if (preg_match('@^https{0,1}://@i', $value)) {
				$res = array();
				$res['@url_complete'] = $value;

				$m = explode('?', $value, 2);
				$res['@url_base'] = $m[0];
				$res['@url_params'] = array();
				if (!isset($m[1])) $m[1] = '';
				parse_str($m[1], $res['@url_params']);

				$value = $res;
				vi3_rec_decode($value);
			} else if (
				(
					($key === 'keywords') ||
					($key === 'fmt_list') ||
					($key === 'fexp') ||
					($key === 'sparams') ||
					($key === 'watermark')
				) || (
					($key !== 'type') &&
					($cc[ord(',')] >= 1)
				)) {
				$value = explode(',', $value);
				vi3_rec_decode($value);
			} else if (($key !== 'type') && ($cc[ord('=')] >= $cc[ord('&')]) && ($cc[ord('=')] >= 1)) {
				parse_str($value, $value);
				vi3_rec_decode($value);
			} else if (($cc[ord('/')] >= 1)) { // for fmt_list
				$value = explode('/', $value);
				vi3_rec_decode($value);
			}




                }
        }
}
